<template>
  <div>
    <v-skeleton-loader
      v-if="recepcionId === 0"
      type="table-heading, image"
    ></v-skeleton-loader>
    <div v-else>
      <div class="d-flex justify-space-between">
        <div style="width: 100px;">
          <v-select
            v-model="perPage"
            :label="$t('totalVisible')"
            :items="listPerPage"
            @change="getDetalleRecepcion"
            dense
          />
        </div>
        <div class="d-flex justify-end">
          <v-btn
            class="mt-2 mr-4"
            color="primary"
            rounded
            small
            @click="refreshTable"
            :disabled="loading"
          >
            <v-icon>mdi-refresh</v-icon>
            {{ $t('actualizar') }}
          </v-btn>
          <v-pagination
            v-model="currentPage"
            :disabled="loading"
            :length="lastPage"
            :total-visible="8"
          />
        </div>
      </div>
      <v-data-table
        v-model="selected"
        :headers="headers"
        :items="detalleRecepcionData"
        item-key="id"
        class="elevation-1"
        disable-pagination
        hide-default-footer
        dense
        :loading="loading"
      >

        <template v-slot:item.actions="{ item }">
          <v-btn
            small
            icon
            @click="eliminarDetalle(item.id)"
          >
            <v-icon>mdi-delete</v-icon>
          </v-btn>
        </template>
      </v-data-table>
    </div>
  </div>
</template>

<script>
import DetalleRecepcionServicio from '@/store/services/DetalleRecepcionServicio'
export default {
  name: "DetalleRecepcionTabla",
  components: {
  },
  props: {
    recepcionId: {
      type: Number,
      required: false,
      default: 0
    }
  },
  data() {
    return {
      listPerPage: [5, 10, 15, this.$t('todo')],
      perPage: 5,
      lastPage: 0,
      total: 0,
      currentPage: 1,
      detalleRecepcionData: [],
      selected: [],
      loading: false,
      detalleRecepcion: null
    }
  },
  methods: {
    verifyType(value) {
      return typeof value;
    },
    async getDetalleRecepcion() {
      this.loading = true;
      const params = {
        page: this.currentPage,
        recepcion_id: this.recepcionId,
        order_by: 'created_at',
        order_direction: 'DESC',
        per_page:
          this.verifyType(this.perPage) === 'string'
            ? this.total
            : this.perPage,
      }
      try {
        let response = await DetalleRecepcionServicio.index(params)
        this.detalleRecepcionData = response.data.data;
        this.currentPage = response.data.current_page;
        this.lastPage = response.data.last_page;
        this.total = response.data.total;
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          console.log(error)
        }
      }
    },
    refreshTable() {
      this.resetCurrentPage();
    },
    resetCurrentPage() {
      if (this.currentPage === 1) this.getDetalleRecepcion();
      else this.currentPage = 1;
    },
    // async guardarDetalle(detalle) {
    //   try {
    //     this.loading = true
    //     await DetalleRecepcionServicio.update(detalle.id, this.form)
    //     .then(() => {
    //       this.refreshTable()
    //     })
    //     this.loading = false;
    //   } catch (error) {
    //     this.loading = false;
    //     if (error.response.status !== 401) {
    //       console.log(error)
    //     }
    //   }
    // },
    editarDetalle(value) {
      this.modal = true
      this.detalleRecepcion = value
    },
    async eliminarDetalle(detalleId) {
      try {
        this.loading = true
        await DetalleRecepcionServicio.remove(detalleId)
        .then(() => {
          this.refreshTable()
        })
        this.loading = false;
      } catch (error) {
        this.loading = false;
        if (error.response.status !== 401) {
          console.log(error)
        }
      }
    },
    resetData() {
      this.form.cantidad = 0
      this.form.precio = 0
      this.form.precio_total = 0
      this.detalleRecepcion = null
    },
    detalleGuardado() {
      this.refreshTable()
    },

  },
  computed: {
    headers() {
      return [
        {
          value: 'actions',
          sortable: false,
        },
        {
          text: this.$t('id'),
          value: 'material.id',
          sortable: false,
        },
        {
          text: this.$t('codigo'),
          value: 'material.codigo',
          sortable: false,
        },
        {
          text: this.$t('descripcion'),
          value: 'material.descripcion',
          sortable: false,
        },
        {
          text: this.$t('unidManejo'),
          value: 'material.unid_manejo',
          sortable: false,
        },
        {
          text: this.$t('cantidad'),
          value: 'cantidad',
          sortable: false,
          align: 'center'
        },
        {
          text: this.$t('marca'),
          value: 'material.marca',
          sortable: false,
        },
        {
          text: this.$t('color'),
          value: 'material.color',
          sortable: false,
        },
        {
          text: this.$t('precio'),
          value: 'precio',
          sortable: false,
        },
        {
          text: this.$t('total'),
          value: 'precio_total',
          sortable: false,
        },
      ];
    },
  },
  watch: {
    currentPage() {
      this.getDetalleRecepcion()
    },
    recepcionId: {
      immediate: true,
      handler() {
        if (this.recepcionId > 0) {
          this.getDetalleRecepcion()
        }
      }
    }
  },
  created() {
  }
}
</script>

<style>

</style>
